diff --git tests/cefclient/browser/osr_render_handler_win_gl.h tests/cefclient/browser/osr_render_handler_win_gl.h
new file mode 100644
index 00000000..606bc70e
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win_gl.h
@@ -0,0 +1,57 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#ifndef CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_GL_H_
+#define CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_GL_H_
+#pragma once
+
+#include "tests/cefclient/browser/osr_render_handler_win.h"
+#include "tests/cefclient/browser/osr_renderer.h"
+
+namespace client {
+
+class OsrRenderHandlerWinGL : public OsrRenderHandlerWin {
+ public:
+  OsrRenderHandlerWinGL(const OsrRendererSettings& settings, HWND hwnd);
+  virtual ~OsrRenderHandlerWinGL();
+
+  // Must be called immediately after object creation.
+  void Initialize(CefRefPtr<CefBrowser> browser);
+
+  void SetSpin(float spinX, float spinY) OVERRIDE;
+  void IncrementSpin(float spinDX, float spinDY) OVERRIDE;
+  bool IsOverPopupWidget(int x, int y) const OVERRIDE;
+  int GetPopupXOffset() const OVERRIDE;
+  int GetPopupYOffset() const OVERRIDE;
+  void OnPopupShow(CefRefPtr<CefBrowser> browser, bool show) OVERRIDE;
+  void OnPopupSize(CefRefPtr<CefBrowser> browser, const CefRect& rect) OVERRIDE;
+  void OnPaint(CefRefPtr<CefBrowser> browser,
+               CefRenderHandler::PaintElementType type,
+               const CefRenderHandler::RectList& dirtyRects,
+               const void* buffer,
+               int width,
+               int height) OVERRIDE;
+  void OnAcceleratedPaint(CefRefPtr<CefBrowser> browser,
+                          CefRenderHandler::PaintElementType type,
+                          const CefRenderHandler::RectList& dirtyRects,
+                          void* share_handle) OVERRIDE;
+
+ private:
+  void Render() OVERRIDE;
+
+  void EnableGL();
+  void DisableGL();
+
+  // The below members are only accessed on the UI thread.
+  OsrRenderer renderer_;
+  HDC hdc_;
+  HGLRC hrc_;
+  bool painting_popup_;
+
+  DISALLOW_COPY_AND_ASSIGN(OsrRenderHandlerWinGL);
+};
+
+}  // namespace client
+
+#endif  // CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_GL_H_
diff --git tests/cefclient/browser/osr_renderer.cc tests/cefclient/browser/osr_renderer.cc
index 3c1cfb70..de2473af 100644
--- tests/cefclient/browser/osr_renderer.cc
+++ tests/cefclient/browser/osr_renderer.cc
@@ -40,7 +40,7 @@
 
 namespace client {
 
-OsrRenderer::OsrRenderer(const Settings& settings)
+OsrRenderer::OsrRenderer(const OsrRendererSettings& settings)
     : settings_(settings),
       initialized_(false),
       texture_id_(0),
diff --git tests/cefclient/browser/osr_renderer.h tests/cefclient/browser/osr_renderer.h
index 95d23fe0..f858d87b 100644
--- tests/cefclient/browser/osr_renderer.h
+++ tests/cefclient/browser/osr_renderer.h
@@ -8,20 +8,13 @@
 
 #include "include/cef_browser.h"
 #include "include/cef_render_handler.h"
+#include "tests/cefclient/browser/osr_renderer_settings.h"
 
 namespace client {
 
 class OsrRenderer {
  public:
-  struct Settings {
-    // If true draw a border around update rectangles.
-    bool show_update_rect;
-
-    // Background color. Enables transparency if the alpha component is 0.
-    cef_color_t background_color;
-  };
-
-  explicit OsrRenderer(const Settings& settings);
+  explicit OsrRenderer(const OsrRendererSettings& settings);
   ~OsrRenderer();
 
   // Initialize the OpenGL environment.
@@ -51,18 +44,19 @@ class OsrRenderer {
   int GetViewWidth() const { return view_width_; }
   int GetViewHeight() const { return view_height_; }
 
-  const CefRect& popup_rect() const { return popup_rect_; }
-  const CefRect& original_popup_rect() const { return original_popup_rect_; }
+  CefRect popup_rect() const { return popup_rect_; }
+  CefRect original_popup_rect() const { return original_popup_rect_; }
 
-  CefRect GetPopupRectInWebView(const CefRect& original_rect);
   void ClearPopupRects();
 
  private:
+  CefRect GetPopupRectInWebView(const CefRect& original_rect);
+
   inline bool IsTransparent() const {
     return CefColorGetA(settings_.background_color) == 0;
   };
 
-  const Settings settings_;
+  const OsrRendererSettings settings_;
   bool initialized_;
   unsigned int texture_id_;
   int view_width_;
diff --git tests/cefclient/browser/osr_renderer_settings.h tests/cefclient/browser/osr_renderer_settings.h
new file mode 100644
index 00000000..535b10a9
--- /dev/null
+++ tests/cefclient/browser/osr_renderer_settings.h
@@ -0,0 +1,38 @@
+// Copyright (c) 2012 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license
+// that can be found in the LICENSE file.
+
+#ifndef CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDERER_SETTINGS_H_
+#define CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDERER_SETTINGS_H_
+#pragma once
+
+#include "include/internal/cef_types.h"
+
+namespace client {
+
+struct OsrRendererSettings {
+  OsrRendererSettings()
+      : show_update_rect(false),
+        background_color(CefColorSetARGB(255, 255, 255, 255)),
+        shared_texture_enabled(false),
+        external_begin_frame_enabled(false),
+        begin_frame_rate(0) {}
+
+  // If true draw a border around update rectangles.
+  bool show_update_rect;
+
+  // Background color. Enables transparency if the alpha component is 0.
+  cef_color_t background_color;
+
+  // Render using shared textures. Supported on Windows only via D3D11.
+  bool shared_texture_enabled;
+
+  // Client implements a BeginFrame timer by calling
+  // CefBrowserHost::SendExternalBeginFrame at the specified frame rate.
+  bool external_begin_frame_enabled;
+  int begin_frame_rate;
+};
+
+}  // namespace client
+
+#endif  // CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDERER_SETTINGS_H_
diff --git tests/cefclient/browser/osr_window_win.cc tests/cefclient/browser/osr_window_win.cc
index 288c964a..cd75f6c6 100644
--- tests/cefclient/browser/osr_window_win.cc
+++ tests/cefclient/browser/osr_window_win.cc
@@ -14,6 +14,8 @@
 #include "tests/cefclient/browser/osr_accessibility_helper.h"
 #include "tests/cefclient/browser/osr_accessibility_node.h"
 #include "tests/cefclient/browser/osr_ime_handler_win.h"
+#include "tests/cefclient/browser/osr_render_handler_win_d3d11.h"
+#include "tests/cefclient/browser/osr_render_handler_win_gl.h"
 #include "tests/cefclient/browser/resource.h"
 #include "tests/shared/browser/geometry_util.h"
 #include "tests/shared/browser/main_message_loop.h"
@@ -25,44 +27,14 @@ namespace {
 
 const wchar_t kWndClass[] = L"Client_OsrWindow";
 
-// Render at 30fps during rotation.
-const int kRenderDelay = 1000 / 30;
-
-// Helper that calls wglMakeCurrent.
-class ScopedGLContext {
- public:
-  ScopedGLContext(HDC hdc, HGLRC hglrc, bool swap_buffers)
-      : hdc_(hdc), swap_buffers_(swap_buffers) {
-    BOOL result = wglMakeCurrent(hdc, hglrc);
-    ALLOW_UNUSED_LOCAL(result);
-    DCHECK(result);
-  }
-  ~ScopedGLContext() {
-    BOOL result = wglMakeCurrent(NULL, NULL);
-    DCHECK(result);
-    if (swap_buffers_) {
-      result = SwapBuffers(hdc_);
-      DCHECK(result);
-    }
-  }
-
- private:
-  const HDC hdc_;
-  const bool swap_buffers_;
-};
-
 }  // namespace
 
 OsrWindowWin::OsrWindowWin(Delegate* delegate,
-                           const OsrRenderer::Settings& settings)
+                           const OsrRendererSettings& settings)
     : delegate_(delegate),
-      renderer_(settings),
+      settings_(settings),
       hwnd_(NULL),
-      hdc_(NULL),
-      hrc_(NULL),
       device_scale_factor_(0),
-      painting_popup_(false),
-      render_task_pending_(false),
       hidden_(false),
       last_mouse_pos_(),
       current_mouse_pos_(),
@@ -80,7 +52,7 @@ OsrWindowWin::OsrWindowWin(Delegate* delegate,
 OsrWindowWin::~OsrWindowWin() {
   CEF_REQUIRE_UI_THREAD();
   // The native window should have already been destroyed.
-  DCHECK(!hwnd_);
+  DCHECK(!hwnd_ && !render_handler_.get());
 }
 
 void OsrWindowWin::CreateBrowser(HWND parent_hwnd,
@@ -103,6 +75,10 @@ void OsrWindowWin::CreateBrowser(HWND parent_hwnd,
   CefWindowInfo window_info;
   window_info.SetAsWindowless(hwnd_);
 
+  window_info.shared_texture_enabled = settings_.shared_texture_enabled;
+  window_info.external_begin_frame_enabled =
+      settings_.external_begin_frame_enabled;
+
   // Create the browser asynchronously.
   CefBrowserHost::CreateBrowser(window_info, handler, startup_url, settings,
                                 request_context);
@@ -127,6 +103,10 @@ void OsrWindowWin::ShowPopup(HWND parent_hwnd,
                      y + static_cast<int>(height)};
   Create(parent_hwnd, rect);
 
+  // Create the render handler.
+  EnsureRenderHandler();
+  render_handler_->SetBrowser(browser_);
+
   // Send resize notification so the compositor is assigned the correct
   // viewport size and begins rendering.
   browser_->GetHost()->WasResized();
@@ -226,7 +206,7 @@ void OsrWindowWin::SetDeviceScaleFactor(float device_scale_factor) {
 
 void OsrWindowWin::Create(HWND parent_hwnd, const RECT& rect) {
   CEF_REQUIRE_UI_THREAD();
-  DCHECK(!hwnd_ && !hdc_ && !hrc_);
+  DCHECK(!hwnd_ && !render_handler_.get());
   DCHECK(parent_hwnd);
   DCHECK(!::IsRectEmpty(&rect));
 
@@ -278,7 +258,7 @@ void OsrWindowWin::Destroy() {
   drop_target_ = NULL;
 #endif
 
-  DisableGL();
+  render_handler_.reset();
 
   // Destroy the native window.
   ::DestroyWindow(hwnd_);
@@ -286,82 +266,6 @@ void OsrWindowWin::Destroy() {
   hwnd_ = NULL;
 }
 
-void OsrWindowWin::EnableGL() {
-  CEF_REQUIRE_UI_THREAD();
-
-  PIXELFORMATDESCRIPTOR pfd;
-  int format;
-
-  // Get the device context.
-  hdc_ = GetDC(hwnd_);
-
-  // Set the pixel format for the DC.
-  ZeroMemory(&pfd, sizeof(pfd));
-  pfd.nSize = sizeof(pfd);
-  pfd.nVersion = 1;
-  pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
-  pfd.iPixelType = PFD_TYPE_RGBA;
-  pfd.cColorBits = 24;
-  pfd.cDepthBits = 16;
-  pfd.iLayerType = PFD_MAIN_PLANE;
-  format = ChoosePixelFormat(hdc_, &pfd);
-  SetPixelFormat(hdc_, format, &pfd);
-
-  // Create and enable the render context.
-  hrc_ = wglCreateContext(hdc_);
-
-  ScopedGLContext scoped_gl_context(hdc_, hrc_, false);
-  renderer_.Initialize();
-}
-
-void OsrWindowWin::DisableGL() {
-  CEF_REQUIRE_UI_THREAD();
-
-  if (!hdc_)
-    return;
-
-  {
-    ScopedGLContext scoped_gl_context(hdc_, hrc_, false);
-    renderer_.Cleanup();
-  }
-
-  if (IsWindow(hwnd_)) {
-    // wglDeleteContext will make the context not current before deleting it.
-    BOOL result = wglDeleteContext(hrc_);
-    ALLOW_UNUSED_LOCAL(result);
-    DCHECK(result);
-    ReleaseDC(hwnd_, hdc_);
-  }
-
-  hdc_ = NULL;
-  hrc_ = NULL;
-}
-
-void OsrWindowWin::Invalidate() {
-  CEF_REQUIRE_UI_THREAD();
-
-  // Don't post another task if the previous task is still pending.
-  if (render_task_pending_)
-    return;
-  render_task_pending_ = true;
-
-  CefPostDelayedTask(TID_UI, base::Bind(&OsrWindowWin::Render, this),
-                     kRenderDelay);
-}
-
-void OsrWindowWin::Render() {
-  CEF_REQUIRE_UI_THREAD();
-
-  if (render_task_pending_)
-    render_task_pending_ = false;
-
-  if (!hdc_)
-    EnableGL();
-
-  ScopedGLContext scoped_gl_context(hdc_, hrc_, true);
-  renderer_.Render();
-}
-
 void OsrWindowWin::NotifyNativeWindowCreated(HWND hwnd) {
   if (!CURRENTLY_ON_MAIN_THREAD()) {
     // Execute this method on the main thread.
@@ -647,8 +551,7 @@ void OsrWindowWin::OnMouseEvent(UINT message, WPARAM wParam, LPARAM lParam) {
       if (mouse_rotation_) {
         // End rotation effect.
         mouse_rotation_ = false;
-        renderer_.SetSpin(0, 0);
-        Invalidate();
+        render_handler_->SetSpin(0, 0);
       } else {
         int x = GET_X_LPARAM(lParam);
         int y = GET_Y_LPARAM(lParam);
@@ -680,11 +583,11 @@ void OsrWindowWin::OnMouseEvent(UINT message, WPARAM wParam, LPARAM lParam) {
         // Apply rotation effect.
         current_mouse_pos_.x = x;
         current_mouse_pos_.y = y;
-        renderer_.IncrementSpin(current_mouse_pos_.x - last_mouse_pos_.x,
-                                current_mouse_pos_.y - last_mouse_pos_.y);
+        render_handler_->IncrementSpin(
+            current_mouse_pos_.x - last_mouse_pos_.x,
+            current_mouse_pos_.y - last_mouse_pos_.y);
         last_mouse_pos_.x = current_mouse_pos_.x;
         last_mouse_pos_.y = current_mouse_pos_.y;
-        Invalidate();
       } else {
         if (!mouse_tracking_) {
           // Start tracking mouse leave. Required for the WM_MOUSELEAVE event to
@@ -819,21 +722,17 @@ bool OsrWindowWin::OnEraseBkgnd() {
 }
 
 bool OsrWindowWin::IsOverPopupWidget(int x, int y) const {
-  CEF_REQUIRE_UI_THREAD();
-  const CefRect& rc = renderer_.popup_rect();
-  int popup_right = rc.x + rc.width;
-  int popup_bottom = rc.y + rc.height;
-  return (x >= rc.x) && (x < popup_right) && (y >= rc.y) && (y < popup_bottom);
+  if (!render_handler_)
+    return false;
+  return render_handler_->IsOverPopupWidget(x, y);
 }
 
 int OsrWindowWin::GetPopupXOffset() const {
-  CEF_REQUIRE_UI_THREAD();
-  return renderer_.original_popup_rect().x - renderer_.popup_rect().x;
+  return render_handler_->GetPopupXOffset();
 }
 
 int OsrWindowWin::GetPopupYOffset() const {
-  CEF_REQUIRE_UI_THREAD();
-  return renderer_.original_popup_rect().y - renderer_.popup_rect().y;
+  return render_handler_->GetPopupYOffset();
 }
 
 void OsrWindowWin::ApplyPopupOffset(int& x, int& y) const {
@@ -848,6 +747,12 @@ void OsrWindowWin::OnAfterCreated(CefRefPtr<CefBrowser> browser) {
   DCHECK(!browser_);
   browser_ = browser;
 
+  if (hwnd_) {
+    // The native window will already exist for non-popup browsers.
+    EnsureRenderHandler();
+    render_handler_->SetBrowser(browser);
+  }
+
   if (hwnd_) {
     // Show the browser window. Called asynchronously so that the browser has
     // time to create associated internal objects.
@@ -861,6 +766,7 @@ void OsrWindowWin::OnBeforeClose(CefRefPtr<CefBrowser> browser) {
   static_cast<ClientHandlerOsr*>(browser_->GetHost()->GetClient().get())
       ->DetachOsrDelegate();
   browser_ = NULL;
+  render_handler_->SetBrowser(NULL);
   Destroy();
 }
 
@@ -923,20 +829,13 @@ bool OsrWindowWin::GetScreenInfo(CefRefPtr<CefBrowser> browser,
 }
 
 void OsrWindowWin::OnPopupShow(CefRefPtr<CefBrowser> browser, bool show) {
-  CEF_REQUIRE_UI_THREAD();
-
-  if (!show) {
-    renderer_.ClearPopupRects();
-    browser->GetHost()->Invalidate(PET_VIEW);
-  }
-  renderer_.OnPopupShow(browser, show);
+  render_handler_->OnPopupShow(browser, show);
 }
 
 void OsrWindowWin::OnPopupSize(CefRefPtr<CefBrowser> browser,
                                const CefRect& rect) {
-  CEF_REQUIRE_UI_THREAD();
-
-  renderer_.OnPopupSize(browser, LogicalToDevice(rect, device_scale_factor_));
+  render_handler_->OnPopupSize(browser,
+                               LogicalToDevice(rect, device_scale_factor_));
 }
 
 void OsrWindowWin::OnPaint(CefRefPtr<CefBrowser> browser,
@@ -945,23 +844,17 @@ void OsrWindowWin::OnPaint(CefRefPtr<CefBrowser> browser,
                            const void* buffer,
                            int width,
                            int height) {
-  CEF_REQUIRE_UI_THREAD();
+  EnsureRenderHandler();
+  render_handler_->OnPaint(browser, type, dirtyRects, buffer, width, height);
+}
 
-  if (painting_popup_) {
-    renderer_.OnPaint(browser, type, dirtyRects, buffer, width, height);
-    return;
-  }
-  if (!hdc_)
-    EnableGL();
-
-  ScopedGLContext scoped_gl_context(hdc_, hrc_, true);
-  renderer_.OnPaint(browser, type, dirtyRects, buffer, width, height);
-  if (type == PET_VIEW && !renderer_.popup_rect().IsEmpty()) {
-    painting_popup_ = true;
-    browser->GetHost()->Invalidate(PET_POPUP);
-    painting_popup_ = false;
-  }
-  renderer_.Render();
+void OsrWindowWin::OnAcceleratedPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    void* share_handle) {
+  EnsureRenderHandler();
+  render_handler_->OnAcceleratedPaint(browser, type, dirtyRects, share_handle);
 }
 
 void OsrWindowWin::OnCursorChange(CefRefPtr<CefBrowser> browser,
@@ -1094,6 +987,31 @@ CefBrowserHost::DragOperationsMask OsrWindowWin::OnDrop(
   return current_drag_op_;
 }
 
+void OsrWindowWin::EnsureRenderHandler() {
+  CEF_REQUIRE_UI_THREAD();
+  if (!render_handler_) {
+    if (settings_.shared_texture_enabled) {
+      // Try to initialize D3D11 rendering.
+      auto render_handler = new OsrRenderHandlerWinD3D11(settings_, hwnd_);
+      if (render_handler->Initialize(browser_,
+                                     client_rect_.right - client_rect_.left,
+                                     client_rect_.bottom - client_rect_.top)) {
+        render_handler_.reset(render_handler);
+      } else {
+        LOG(ERROR) << "Failed to initialize D3D11 rendering.";
+        delete render_handler;
+      }
+    }
+
+    // Fall back to GL rendering.
+    if (!render_handler_) {
+      auto render_handler = new OsrRenderHandlerWinGL(settings_, hwnd_);
+      render_handler->Initialize(browser_);
+      render_handler_.reset(render_handler);
+    }
+  }
+}
+
 #endif  // defined(CEF_USE_ATL)
 
 }  // namespace client
diff --git tests/cefclient/browser/osr_window_win.h tests/cefclient/browser/osr_window_win.h
index 900af2d8..effa97e6 100644
--- tests/cefclient/browser/osr_window_win.h
+++ tests/cefclient/browser/osr_window_win.h
@@ -13,7 +13,8 @@
 #include "tests/cefclient/browser/client_handler_osr.h"
 #include "tests/cefclient/browser/osr_accessibility_node.h"
 #include "tests/cefclient/browser/osr_dragdrop_win.h"
-#include "tests/cefclient/browser/osr_renderer.h"
+#include "tests/cefclient/browser/osr_render_handler_win.h"
+#include "tests/cefclient/browser/osr_renderer_settings.h"
 
 namespace client {
 
@@ -27,7 +28,7 @@ class OsrWindowWin
     : public base::RefCountedThreadSafe<OsrWindowWin, CefDeleteOnUIThread>,
       public ClientHandlerOsr::OsrDelegate
 #if defined(CEF_USE_ATL)
-      ,
+    ,
       public OsrDragEvents
 #endif
 {
@@ -44,7 +45,7 @@ class OsrWindowWin
   };
 
   // |delegate| must outlive this object.
-  OsrWindowWin(Delegate* delegate, const OsrRenderer::Settings& settings);
+  OsrWindowWin(Delegate* delegate, const OsrRendererSettings& settings);
 
   // Create a new browser and native window.
   void CreateBrowser(HWND parent_hwnd,
@@ -63,6 +64,8 @@ class OsrWindowWin
   void SetFocus();
   void SetDeviceScaleFactor(float device_scale_factor);
 
+  const OsrRendererSettings& settings() const { return settings_; }
+
  private:
   // Only allow deletion via scoped_refptr.
   friend struct CefDeleteOnThread<TID_UI>;
@@ -74,14 +77,6 @@ class OsrWindowWin
   void Create(HWND parent_hwnd, const RECT& rect);
   void Destroy();
 
-  // Manage GL context lifespan.
-  void EnableGL();
-  void DisableGL();
-
-  // Redraw what is currently in the texture.
-  void Invalidate();
-  void Render();
-
   void NotifyNativeWindowCreated(HWND hwnd);
 
   static void RegisterOsrClass(HINSTANCE hInstance, HBRUSH background_brush);
@@ -130,6 +125,10 @@ class OsrWindowWin
                const void* buffer,
                int width,
                int height) OVERRIDE;
+  void OnAcceleratedPaint(CefRefPtr<CefBrowser> browser,
+                          CefRenderHandler::PaintElementType type,
+                          const CefRenderHandler::RectList& dirtyRects,
+                          void* share_handle) OVERRIDE;
   void OnCursorChange(CefRefPtr<CefBrowser> browser,
                       CefCursorHandle cursor,
                       CefRenderHandler::CursorType type,
@@ -163,14 +162,14 @@ class OsrWindowWin
       CefBrowserHost::DragOperationsMask effect) OVERRIDE;
 #endif  // defined(CEF_USE_ATL)
 
+  void EnsureRenderHandler();
+
   // Only accessed on the main thread.
   Delegate* delegate_;
 
-  // The below members are only accessed on the UI thread.
-  OsrRenderer renderer_;
+  const OsrRendererSettings settings_;
   HWND hwnd_;
-  HDC hdc_;
-  HGLRC hrc_;
+  std::unique_ptr<OsrRenderHandlerWin> render_handler_;
 
   // Class that encapsulates IMM32 APIs and controls IMEs attached to a window.
   scoped_ptr<OsrImeHandlerWin> ime_handler_;
@@ -190,8 +189,6 @@ class OsrWindowWin
   IAccessible* accessibility_root_;
 #endif
 
-  bool painting_popup_;
-  bool render_task_pending_;
   bool hidden_;
 
   // Mouse state tracking.
diff --git tests/cefclient/browser/root_window_gtk.cc tests/cefclient/browser/root_window_gtk.cc
index 480dd096..c8c29d9f 100644
--- tests/cefclient/browser/root_window_gtk.cc
+++ tests/cefclient/browser/root_window_gtk.cc
@@ -231,7 +231,7 @@ bool RootWindowGtk::WithExtension() const {
 
 void RootWindowGtk::CreateBrowserWindow(const std::string& startup_url) {
   if (with_osr_) {
-    OsrRenderer::Settings settings = {};
+    OsrRendererSettings settings = {};
     MainContext::Get()->PopulateOsrSettings(&settings);
     browser_window_.reset(new BrowserWindowOsrGtk(this, startup_url, settings));
   } else {
diff --git tests/cefclient/browser/root_window_mac.mm tests/cefclient/browser/root_window_mac.mm
index 429f1303..87235014 100644
--- tests/cefclient/browser/root_window_mac.mm
+++ tests/cefclient/browser/root_window_mac.mm
@@ -445,7 +445,7 @@ void RootWindowMac::WindowDestroyed() {
 
 void RootWindowMac::CreateBrowserWindow(const std::string& startup_url) {
   if (with_osr_) {
-    OsrRenderer::Settings settings = {};
+    OsrRendererSettings settings = {};
     MainContext::Get()->PopulateOsrSettings(&settings);
     browser_window_.reset(new BrowserWindowOsrMac(this, startup_url, settings));
   } else {
diff --git tests/cefclient/browser/root_window_win.cc tests/cefclient/browser/root_window_win.cc
index 64e58b9c..b8c0461e 100644
--- tests/cefclient/browser/root_window_win.cc
+++ tests/cefclient/browser/root_window_win.cc
@@ -301,7 +301,7 @@ bool RootWindowWin::WithExtension() const {
 
 void RootWindowWin::CreateBrowserWindow(const std::string& startup_url) {
   if (with_osr_) {
-    OsrRenderer::Settings settings = {};
+    OsrRendererSettings settings = {};
     MainContext::Get()->PopulateOsrSettings(&settings);
     browser_window_.reset(new BrowserWindowOsrWin(this, startup_url, settings));
   } else {
diff --git tests/shared/browser/client_app_browser.cc tests/shared/browser/client_app_browser.cc
index fe2f2cae..038d3e29 100644
--- tests/shared/browser/client_app_browser.cc
+++ tests/shared/browser/client_app_browser.cc
@@ -21,15 +21,8 @@ void ClientAppBrowser::OnBeforeCommandLineProcessing(
   // Pass additional command-line flags to the browser process.
   if (process_type.empty()) {
     // Pass additional command-line flags when off-screen rendering is enabled.
-    if (command_line->HasSwitch(switches::kOffScreenRenderingEnabled)) {
-      // If the PDF extension is enabled then cc Surfaces must be disabled for
-      // PDFs to render correctly.
-      // See https://bitbucket.org/chromiumembedded/cef/issues/1689 for details.
-      if (!command_line->HasSwitch("disable-extensions") &&
-          !command_line->HasSwitch("disable-pdf-extension")) {
-        command_line->AppendSwitch("disable-surfaces");
-      }
-
+    if (command_line->HasSwitch(switches::kOffScreenRenderingEnabled) &&
+        !command_line->HasSwitch(switches::kSharedTextureEnabled)) {
       // Use software rendering and compositing (disable GPU) for increased FPS
       // and decreased CPU usage. This will also disable WebGL so remove these
       // switches if you need that capability.
diff --git tests/shared/browser/util_win.cc tests/shared/browser/util_win.cc
index a4b7b992..0be060fc 100644
--- tests/shared/browser/util_win.cc
+++ tests/shared/browser/util_win.cc
@@ -8,6 +8,22 @@
 
 namespace client {
 
+namespace {
+
+LARGE_INTEGER qi_freq_ = {};
+
+}  // namespace
+
+uint64_t GetTimeNow() {
+  if (!qi_freq_.HighPart && !qi_freq_.LowPart) {
+    QueryPerformanceFrequency(&qi_freq_);
+  }
+  LARGE_INTEGER t = {};
+  QueryPerformanceCounter(&t);
+  return static_cast<uint64_t>((t.QuadPart / double(qi_freq_.QuadPart)) *
+                               1000000);
+}
+
 void SetUserDataPtr(HWND hWnd, void* ptr) {
   SetLastError(ERROR_SUCCESS);
   LONG_PTR result =
diff --git tests/shared/browser/util_win.h tests/shared/browser/util_win.h
index 83919e98..a46d77e2 100644
--- tests/shared/browser/util_win.h
+++ tests/shared/browser/util_win.h
@@ -13,6 +13,9 @@
 
 namespace client {
 
+// Returns the current time in microseconds.
+uint64_t GetTimeNow();
+
 // Set the window's user data pointer.
 void SetUserDataPtr(HWND hWnd, void* ptr);
 
diff --git tests/shared/common/client_switches.cc tests/shared/common/client_switches.cc
index cfd68aa0..d5cf11d6 100644
--- tests/shared/common/client_switches.cc
+++ tests/shared/common/client_switches.cc
@@ -25,6 +25,8 @@ const char kOffScreenRenderingEnabled[] = "off-screen-rendering-enabled";
 const char kOffScreenFrameRate[] = "off-screen-frame-rate";
 const char kTransparentPaintingEnabled[] = "transparent-painting-enabled";
 const char kShowUpdateRect[] = "show-update-rect";
+const char kSharedTextureEnabled[] = "shared-texture-enabled";
+const char kExternalBeginFrameEnabled[] = "external-begin-frame-enabled";
 const char kMouseCursorChangeDisabled[] = "mouse-cursor-change-disabled";
 const char kRequestContextPerBrowser[] = "request-context-per-browser";
 const char kRequestContextSharedCache[] = "request-context-shared-cache";
diff --git tests/shared/common/client_switches.h tests/shared/common/client_switches.h
index 2bd34cb8..c6f6e8b2 100644
--- tests/shared/common/client_switches.h
+++ tests/shared/common/client_switches.h
@@ -19,6 +19,8 @@ extern const char kOffScreenRenderingEnabled[];
 extern const char kOffScreenFrameRate[];
 extern const char kTransparentPaintingEnabled[];
 extern const char kShowUpdateRect[];
+extern const char kSharedTextureEnabled[];
+extern const char kExternalBeginFrameEnabled[];
 extern const char kMouseCursorChangeDisabled[];
 extern const char kRequestContextPerBrowser[];
 extern const char kRequestContextSharedCache[];
